#include <iostream>
#include <vector>
#include <math.h>
#include <bits/stdc++.h>

using namespace std;

typedef vector<double> vd;
const double eps = 1e-12;

vector<vd> A(3, vd(3));
vd b(3), x(3);

int SolveLinear(vector<vd> &A, vd &b, vd &x) {
    int n = A.size(), m = x.size(), rk = 0, br, bc;
    vector<int> col(m); iota(col.begin(), col.end(), 0);

    for(int i = 0; i < n; ++i) {
        double v, bv = 0;
        for(int r = i; r < n; ++r)
            for(int c = i; c < m; ++c)
            if ((v = fabs(A[r][c])) > bv) {
                br = r;
                bc = c;
                bv = v;
            }
        if (bv <= eps) {
            for(int j = i; j < n; ++j)
                if (fabs(b[j]) > eps) return -1;
            break;
        }
        swap(A[i], A[br]);
        swap(b[i], b[br]);
        swap(col[i], col[bc]);
        for(int j = 0; j < n; ++j)
            swap(A[j][i], A[j][bc]);
        bv = 1 / A[i][i];
        for(int j = i + 1; j < n; ++j) {
            double fac = A[j][i] * bv;
            b[j] -= fac * b[i];
            for(int k = i + 1; k < m; ++k)
                A[j][k] -= fac * A[i][k];
        }
        rk++;
    }

    x.assign(m, 0);
    for(int i = rk; i--;) {
        b[i] /= A[i][i];
        x[col[i]] = b[i];
        for(int j = 0; j < i; ++j) b[j] -= A[j][i] * b[i];
    }
    return rk;
}

int main()
{
    ios_base::sync_with_stdio(false);
    while (cin >> A[0][0] >> A[0][1] >> A[0][2]) {
        if (A[0][0] == A[0][1] && A[0][1] == A[0][2] && A[0][0] == 0)
            break;
        for(int i = 1; i < 3; ++i)
            for(int j = 0; j < 3; ++j) cin >> A[i][j];
        cin >> b[0] >> b[1] >> b[2];
//        Solve_Buff();
        int solvable = SolveLinear(A, b, x);
//        for(auto a: x) cout << a << ' ';
//        cout << solvable << '\n';
        string res = "YES";
        for(auto a: x)
            if (!(a > 0)) {
                res = "NO";
                break;
            }
        cout << res << '\n';
    }
    return 0;
}
