#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

bool check(const vector<double>& vec, double w) 
{
    for (int i = 1; i < vec.size(); ++i) {
        if (vec[i] - vec[i-1] > w)  {
            return false;
        }
    }
    return true;
}

int main()
{
    cin.tie(NULL);
    ios::sync_with_stdio(false);

    int nx, ny;
    double w;
    while (true) {
        cin >> nx >> ny >> w;
        if (nx == 0 && ny == 0 && abs(w) < 0.00001) break;

        vector<double> xs (nx);
        for(double& d : xs) cin >> d;

        vector<double> ys (ny);
        for(double& d : ys) cin >> d;

        xs.push_back(-w/2);
        xs.push_back(75+w/2);

        ys.push_back(-w/2);
        ys.push_back(100+w/2);

        sort(begin(xs), end(xs));
        sort(begin(ys), end(ys));

        if (check (xs, w) && check (ys, w)) {
            cout << "YES\n";
        } else {
            cout << "NO\n";
        }
    }
}