#include <vector>
#include <utility>
#include <map>
#include <iostream>
#include <limits>

using namespace std;

typedef pair<int, unsigned long> cell;


int bindi(int a, int b) {
	return a * 100 + b;
}

int main() {
	cin.tie(NULL);
	ios::sync_with_stdio(false);


	int k;
	cin >> k;
	while (k) {

		map<char, int> chmap;
		map<int, char> revchmap;
		for (int i = 0; i < k; ++i) {
			char chr;
			cin >> chr;
			chmap[chr] = i;
			revchmap[i] = chr;
			//cout << chr << i << endl;
		}

		map<int, cell> M;
		for (int i = 0; i < k; ++i) {
			for (int j = 0; j < k; ++j) {
				unsigned long val;
				string str;
				cin >> val >> str;
				//cout << val << str[1] << endl;
				M[bindi(i, j)] = cell(chmap[str[1]], val);
			}
		}

		int n = 5;
		cin >> n;
		for (int ni = 0; ni < n; ++ni) {
			string expr;
			cin >> expr;
			int m = expr.size();
			vector<vector<cell>> T(m, vector<cell>(m));
			for (int i = 0; i < m; ++i) {
				T[i][i] = cell(chmap[expr[i]], 0);
			}

			for (int d = 0; d < m - 1; ++d) {
				for (int i = 0, j = d + 1; i < m - d - 1; i++, j++) {
					int min_chr = 'z'+1;
					unsigned long min_val = numeric_limits<unsigned long>::max();
					for (int l = 0; l < d+1; ++l) {
						const cell& a = T[i][i+l];
						const cell& b = T[i+l+1][j];
						const cell& c = M[bindi(a.first, b.first)];
						unsigned long curr_val = a.second + b.second + c.second;
						if (curr_val < min_val || (curr_val == min_val && c.first < min_chr)) {
							min_chr = c.first;
							min_val = curr_val;
						}
					}
					T[i][j] = cell(min_chr, min_val);
				}
			}
			cout << T[0][m - 1].second << '-' << revchmap[T[0][m - 1].first] << '\n';
		}

        cout << '\n';



		cin >> k;
	}

}