#include <bits/stdc++.h>

using namespace std;

const double EPS = 1e-10;

typedef vector<int> VI;
typedef double T;
typedef vector<T> VT;
typedef vector<VT> VVT;

T GaussJordan(VVT &a, VVT &b){
    const int n = a.size();
    const int m = b[0].size();
    VI irow(n), icol(n), ipiv(n);
    T det = 1;

    for(int i = 0; i<n; ++i){
        int pj = -1, pk = -1;
        for(int j = 0; j<n; ++j) if(!ipiv[j])
            for(int k = 0; k<n; ++k) if(!ipiv[k])
                if(pj == -1 || fabs(a[j][k]) > fabs(a[pj][pk])) {pj = j; pk = k;}
        if(fabs(a[pj][pk]) < EPS) return 0;
        ++ipiv[pk];
        swap(a[pj], a[pk]);
        swap(b[pj], b[pk]);
        if(pj != pk) det *= -1;
        irow[i] = pj;
        icol[i] = pk;

        T c = 1.0 / a[pk][pk];
        det *= a[pk][pk];
        a[pk][pk] = 1.0;
        for(int p = 0; p < n; ++p) a[pk][p] *= c;
        for(int p = 0; p < m; ++p) b[pk][p] *= c;
        for(int p = 0; p < n; ++p) if(p != pk) {
            c = a[p][pk];
            a[p][pk] = 0;
            for(int q = 0; q < n; ++q) a[p][q] -= a[pk][q] * c;
            for(int q = 0; q < m; ++q) b[p][q] -= b[pk][q] * c;
        }
    }

    for(int p = n - 1; p >= 0; --p) if(irow[p] != icol[p]){
        for(int k = 0; k<n; ++k) swap(a[k][irow[p]], a[k][icol[p]]);
    }
    return det;
}

int main(){
    cin.tie(NULL);
    ios::sync_with_stdio(false);
    
    while(true){
        VVT a = vector<vector<double>>(3, vector<double>(3));
        cin >> a[0][0] >> a[0][1] >> a[0][2];
        if(a[0][0] == 0 && a[0][1] == 0 &&  a[0][2] == 0) break;
        for(int i = 1; i<3; ++i){
            for(int j = 0; j<3; ++j){
                cin >> a[i][j];
            }
        }
        VVT b = vector<vector<double>>(3, vector<double>(1));
        for(int i = 0; i<3; ++i){
            cin >> b[i][0];
        }
        double det = GaussJordan(a, b);
        if(det == 0){
            cout << "NO\n";
        }
        bool ok = true;
        for(int i = 0;i<3; ++i){
            if(!(b[i][0] > 0 && b[i][0] < 1)){
                ok = false;
            }
        }
        if(ok){
            cout << "YES\n";
        }
        else{
            cout << "NO\n";
        }

    }
}