#include <iostream>
#include <vector>

using namespace std;

int buffer[10000];
string s;
vector<bool> volt, valt;
vector<vector<int>> g;
vector<char> ert;

int Ind(char c)
{
    if(c == 'A')
        return 0;
    if(c == 'G')
        return 1;
    if(c == 'T')
        return 2;
    return 3;
}

char KarakterKov(int x)
{
    if(x == 0)
        return 'G';
    if(x == 1)
        return 'T';
    if(x == 2)
        return 'C';
    return 'A';
}

char KarakterElozo(int x)
{
    if(x == 0)
        return 'C';
    if(x == 1)
        return 'A';
    if(x == 2)
        return 'G';
    return 'T';
}

bool Bejar(int x, char c)
{
    //cout<<"p: "<<x<<" "<<c<<" "<<g[x].size()<<"\n";
    volt[x] = true;
    if(s[x] != c)
    {
        ert[x] = c;
        valt[x] = true;
        if(x > 0 && valt[x-1])
            return false;
        else if(x > 0 && !volt[x-1])
        {
            if(!Bejar(x-1, s[x-1]))
                return false;
        }
        if(x < s.size()-1 && valt[x+1])
            return false;
        else if(x < s.size()-1 && !volt[x+1])
        {
            if(!Bejar(x+1, s[x+1]))
                return false;
        }
    }
    else
        ert[x] = s[x];

    for(int i = 0; i < g[x].size(); i++)
    {
        if(!volt[g[x][i]])
        {
            if(!Bejar(g[x][i], c))
                return false;
        }
        else if(ert[g[x][i]] != c)
            return false;
    }

    return true;
}

int main()
{
    cin.sync_with_stdio(false);
    cin.tie(0);

     int n, m;
    while(cin>>n>>m)
    {
        if(n == 0 && m == 0)
            break;
        cin>>s;

        g.clear();
        g.resize(n);

        char c;

        for(int i = 0; i < m; i++)
        {
            int a;
            cin>>a>>c;
            for(int i = 0; i < a; i++)
                cin>>buffer[i];

            for(int i = 0; i < a; i++)
                g[buffer[i]].push_back(buffer[a-i-1]);
        }

        volt.assign(n, false);
        valt.assign(n, false);
        ert.resize(n);
        bool van = true;
        vector<bool> v1 = volt, v2 = valt;
        for(int i = 0; i < n; i++)
        {
            bool kesz = false;
            if(!volt[i] && g[i].size() > 0)
            {
                char c = s[i];//KarakterKov(Ind(s[i]));

                if(Bejar(i, c))
                    kesz = true;

                if(!kesz)
                {
                    volt = v1;
                    valt = v2;
                    char c = KarakterKov(Ind(s[i]));

                    if(Bejar(i, c))
                        kesz = true;
                }

                if(!kesz)
                {
                    volt = v1;
                    valt = v2;
                    char c = KarakterElozo(Ind(s[i]));

                    if(Bejar(i, c))
                        kesz = true;
                }

                if(!kesz)
                {
                    van = false;
                    break;
                }
            }
        }

        if(van)
            cout<<"YES\n";
        else
            cout<<"NO\n";

    }

    return 0;
}
