#include <bits/stdc++.h>

using namespace std;

#define MAXK 26
#define MAXLEN 200
#define INF ((int)1e9 + 7)

static char chartable[MAXK];
static int idxtable[MAXK];
static int costtable[MAXK][MAXK];
static char restable[MAXK][MAXK];

static bool cando[MAXLEN][MAXLEN][MAXK];
static int cost[MAXLEN][MAXLEN];

static char s[MAXLEN+1];

struct answer { int cost; char res; };

static answer solve(const int maxk) {
		
	int n = strlen(s);
	
	//printf("n = %d\n", n);
	
	memset(cando, 0, sizeof cando);
	
	for (int i = 0; i < n; i++) {
		cost[i][i] = 0;
		cando[i][i][  idxtable[ s[i]-'a' ] ] = true;
	}
	
	for (int i = n-1; i >= 0; i--) {
		for (int j = i+1; j < n; j++) {
			cost[i][j] = INF;
			for (int k = i; k < j; k++) {

				for (int p = 0; p < maxk; p++) {
					//printf("cando(%d, %d, %c) = %d\n", i, k, chartable[p], cando[i][k][p]);
					
					if (!cando[i][k][p])
						continue;
					
					for (int q = 0; q < maxk; q++) {
						//printf("cando(%d, %d, %c) = %d\n", k+1, j, chartable[q], cando[k+1][j][q]);
						if (!cando[k+1][j][q])
							continue;
					

						int c = cost[i][k] + cost[k+1][j] + costtable[ chartable[p]-'a' ][ chartable[q]-'a' ];
						int r = restable[ chartable[p]-'a' ][ chartable[q]-'a' ]; 
					
						//printf("%d %d %d : %c + %c -> %c ; +%d\n", i, j, k, chartable[p], chartable[q], r, costtable[ chartable[p]-'a' ][ chartable[q]-'a' ]);
						
						if (c < cost[i][j]) {
							cost[i][j] = c;
							fill(begin(cando[i][j]), end(cando[i][j]), false);
							cando[i][j][ idxtable[r-'a'] ] = true;
						}
						else if (c == cost[i][j]) {
							cando[i][j][ idxtable[r-'a'] ] = true;
						}
						
					}	
				}
			}
			
			//printf("cost(%d, %d) = %d\n", i, j, cost[i][j]);
		}
	}
	
	for (int i = 0; i < maxk; i++) {
		//printf("%c: %d\n", chartable[i], (int)cando[0][n-1][i]);
		if (cando[0][n-1][i])
			return {.cost = cost[0][n-1], .res = chartable[i]};
	}
	
	abort();
}


int main() {

#ifndef ONLINE_JUDGE
	freopen("in.1", "r", stdin);
#endif
	
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	
	
	
	int k, n;
	while (scanf(" %d ", &k) == 1 && k > 0) {
	
		for (int i = 0; i < k; i++) {
			char c;
			scanf(" %c ", &c);

			idxtable[c-'a'] = i;
			chartable[i] = c;
		}
		
		for (int i = 0; i < k; i++) {
			
			for (int j = 0; j < k; j++) {	
				
				int c;
				char r;
				
				scanf(" %d-%c ", &c, &r);
				
				restable[ chartable[i]-'a' ][ chartable[j]-'a' ] = r;
				costtable[ chartable[i]-'a' ][ chartable[j]-'a' ] = c;
			}
		}
		
		scanf(" %d ", &n);
		
		for (int i = 0; i < n; i++) {	
			memset(s, 0, sizeof s);
			
			fgets(s, sizeof s, stdin);
			s[strlen(s)-1] = '\0';
			
			//printf("s = '%s'\n", s);
			
			auto ans = solve(k);
			printf("%d-%c\n", ans.cost, ans.res);
		}
		
		printf("\n");
	}
	
	
	
		
	return 0;
}


