import java.util.*;
import java.util.stream.Collectors;

public class LawnMower {
    private static class Ertek {
        double a, b;

        Ertek(double a, double b) {
            this.a = a;
            this.b = b;
        }
    }

    public static void main(String[] args) {
        int x, y;
        double w, temp;
        double height = 75.0, width = 100.0;
        double eredm1, eredm2;

        List<Ertek> adatok = new ArrayList<>();

        Scanner sc = new Scanner(System.in);
        sc.useLocale(Locale.ENGLISH);

        try {
            while (true) {
                x = sc.nextInt();
                y = sc.nextInt();
                w = sc.nextDouble() / 2;

                if (x == 0 && y == 0) break;

                adatok.clear();
                for (int i = 0; i < x; ++i) {
                    temp = sc.nextDouble();
                    adatok.add(new Ertek(temp - w, temp + w));
                }
                eredm1 = feldolgoz(adatok);

                adatok.clear();
                for (int i = 0; i < y; ++i) {
                    temp = sc.nextDouble();
                    adatok.add(new Ertek(temp - w, temp + w));
                }
                eredm2 = feldolgoz(adatok);

                if (eredm1 >= height && eredm2 >= width) System.out.println("YES");
                else System.out.println("NO");
            }
        }
        catch (Exception e) {
            e.printStackTrace();
        }
        sc.close();
    }

    private static double feldolgoz(List<Ertek> adatok) {
        adatok = adatok.stream()
                .sorted(Comparator.comparing(c -> c.a))
                .collect(Collectors.toList());

        for (int i = 1; i < adatok.size(); ++i) {
            if (adatok.get(i - 1).b < adatok.get(i).a) {
                return -1.0;
            }
        }
        return adatok.get(adatok.size()-1).b;
    }
}
