import java.util.*;
import java.util.stream.Collectors;

public class Boxes {
    static class City {
        long popul;
        long boxes;

        City(long popul) {
            this.popul = popul;
            this.boxes = 0;
        }

        void setBoxes(long boxes) {
            this.boxes = boxes;
        }
    }

    public static void main(String[] args) {
        long cities, boxes, temp;
        long sum;

        List<City> adatok = new ArrayList<>();

        Scanner sc = new Scanner(System.in);
        sc.useLocale(Locale.ENGLISH);

        try {
            while (true) {
                cities = sc.nextLong();
                boxes = sc.nextLong();

                if (cities == -1 && boxes == -1) break;

                adatok.clear();
                sum = 0;
                for (int i = 0; i < cities; ++i) {
                    temp = sc.nextLong();
                    adatok.add(new City(temp));
                    sum += temp;
                }

                adatok = adatok.stream()
                        .sorted(Comparator.comparing(a -> a.popul))
                        .collect(Collectors.toList());

                long boxesPerCity, tempBoxes;
                for (City city : adatok) {
                    boxesPerCity = sum / boxes;
                    tempBoxes = (long) Math.ceil((double) city.popul / boxesPerCity);
                    city.setBoxes(tempBoxes);
                    boxes -= tempBoxes;
                    sum -= city.popul;
                }

                System.out.println((int)adatok.get(adatok.size() - 1).popul / adatok.get(adatok.size() - 1).boxes);
            }
        }
        catch (Exception ignored) {}
        sc.close();
    }
}
