import java.util.*;
import java.util.stream.Collectors;

public class Boxes {
    static class City {
        int popul;
        int boxes;

        City(int popul) {
            this.popul = popul;
            this.boxes = 0;
        }

        void setBoxes(int boxes) {
            this.boxes = boxes;
        }
    }

    public static void main(String[] args) {
        int cities, boxes, temp;
        int sum;

        List<City> adatok = new ArrayList<>();

        Scanner sc = new Scanner(System.in);
        sc.useLocale(Locale.ENGLISH);

        try {
            while (true) {
                cities = sc.nextInt();
                boxes = sc.nextInt();

                if (cities == -1 && boxes == -1) break;

                adatok.clear();
                sum = 0;
                for (int i = 0; i < cities; ++i) {
                    temp = sc.nextInt();
                    adatok.add(new City(temp));
                    sum += temp;
                }

                adatok = adatok.stream()
                        .sorted(Comparator.comparing(a -> a.popul))
                        .collect(Collectors.toList());

                int boxesPerCity, tempBoxes;
                for (City city : adatok) {
                    boxesPerCity = sum / boxes;
                    tempBoxes = (int) Math.ceil((double) city.popul / boxesPerCity);
                    city.setBoxes(tempBoxes);
                    boxes -= tempBoxes;
                    sum -= city.popul;
                }

                System.out.println((int)adatok.get(adatok.size() - 1).popul / adatok.get(adatok.size() - 1).boxes);

                if (!sc.hasNextLine()) break;
            }
        }
        catch (Exception ignored) {}
        sc.close();
    }
}
